#include <string.h>
#include <stdio.h>

#include "types.h"

#include "command_ext.h" 

void generateExternalCommand ( char command, char* data, unsigned int dataLength, char* output )
{
    char encoded[MAXDATALENGTH];
    memset ( encoded, '\0', sizeof ( encoded ) );

    addStart ( output );
    addCommand ( output, command );
    encode64 ( data, encoded, dataLength );
    addData ( output, encoded );
    addCRC ( output );
    addEnd ( output );
}

void decodeExternalCommand ( char* inputString, uint8_t *command, char* decodedData )
{
    *command = inputString[1];
    uint16_t dataLength = strlen ( inputString ) - 5; //1 start, 1 command, 2 crc, 1 end
    char encodedData[dataLength+1];
    memset ( encodedData, '\0', dataLength+1 );

    strncpy ( encodedData, inputString+2, dataLength ); //1 start, 1 command

    decode64 ( encodedData, dataLength/4*3, decodedData );
}
