#include <string.h>

#include "types.h"

#include "command_int.h"

void generateInternalCommand ( int address, char command, char* data, unsigned int dataLength, char* output )
{

    char encoded[150];
    memset ( encoded, '\0', sizeof ( encoded ) );

    addStart ( output );
    addAddress ( output, address );
    addCommand ( output, command );
    encode64 ( data, encoded, dataLength );
    addData ( output, encoded );
    addCRC ( output );
    addEnd ( output );

}

void decodeInternalCommand ( char* answer, uint16_t *address, uint8_t *command, char* decodedData )
{
    *address = answer[1] - 'a';
    *command = answer[2];
    uint16_t dataLength = strlen ( answer ) - 6; //1 start, 1 address, 1 command, 2 crc, 1 end
    char encodedData[dataLength+1];
    memset ( encodedData, '\0', dataLength+1 );

    strncpy ( encodedData, answer+3, dataLength ); //1 start, 1 address, 1 command

    decode64 ( encodedData, dataLength/4*3, decodedData );
}
