#ifndef _CONSTANTS_H
#define _CONSTANTS_H

#include <stdint.h>

#define TRUE 1
#define FALSE 0
#define SUCCESS 2
#define FAILURE 3
#define UNKNOWN 4

#define MKIP "localhost"
#define NB1IP "130.92.64.27"
#define NB1MAC "00:11:2f:e5:02:bc"
#define NB2IP ""
#define NB2MAC ""
#define DEFAULTINTERFACE "br0"
#define DEFAULTSERIALDEVICE "/dev/ttyS0"
#define MULTICASTADDR "FF02::1"
#define MAXLINELENGTH 200
#define MAXDATALENGTH 200
#define MAXHOSTNAMELENGTH 30
#define MAXIPV4LENGTH 16
#define IN_RANGE_RADIUS 3 //in meter

#define MAXSIGNALSTRENGTHDIFF 10
#define OPTIMALSIGNALSTRENGTH -90
#define OPTIMALMESHSIGNALSTRENGTH -100

#define PREFERIPV6 FALSE

#define MAXBUFLEN 1023

#define MAXPENDINGCONNECTIONS 10

#define MAX_NOTIFICATION_SUBSCRIBER 20
#define MAX_UAVS 3
#define MAX_STATE_FIXER_PINGS 10

#define SERIALCONNECTIONPATTERN 8273

enum UAV_PORTS {
    UAV_PORT_COMMUNICATION = 7654,
    UAV_PORT_PING = 7655,
    UAV_PORT_NOTIFICATION = 7656
};

enum UAV_ADDRESS {
    UAV_ADDRESS_ALL = 0, //a
    UAV_ADDRESS_FC = 1,  //b
    UAV_ADDRESS_NC = 2,  //c
    UAV_ADDRESS_MK3 = 3  //d
};

enum UAV_SCENARIO {
    UAV_SCENARIO_NONE = 0,
    UAV_SCENARIO_AIRBORNE = 1,
    UAV_SCENARIO_MULTIHOP = 2,
    UAV_SCENARIO_COVERAGE = 3
};

enum UAV_STATE {
    UAV_STATE_UNINITIALIZED = 0,
    UAV_STATE_UNCONFIGURED = 1,
    UAV_STATE_AIRBORNE_AWAITING_POS1 = 2,
    UAV_STATE_AIRBORNE_AWAITING_FLIGHT_DIRECTION = 3,
    UAV_STATE_AIRBORNE_AWAITING_POS2 = 4,
    UAV_STATE_AIRBORNE_REACHED_MAX_DISTANCE = 5,
    UAV_STATE_AIRBORNE_FLYING_CENTER = 6,
    UAV_STATE_AIRBORNE_REACHED_CENTER = 7,
    UAV_STATE_FLYING_HOME = 8,
    UAV_STATE_HOME = 9,
    UAV_STATE_ABORTED = 10,
    UAV_STATE_MULTIHOP_1_AWAITING_POS1 = 11,
    UAV_STATE_MULTIHOP_1_AWAITING_FLIGHT_DIRECTION = 12,
    UAV_STATE_MULTIHOP_1_AWAITING_POS2 = 13,
    UAV_STATE_MULTIHOP_1_REACHED_MAX_DISTANCE = 14,
    UAV_STATE_MULTIHOP_1_FLYING_CENTER = 15,
    UAV_STATE_MULTIHOP_1_REACHED_CENTER = 16,
    UAV_STATE_MULTIHOP_1_FLYING_FINAL_POSITION = 17,
    UAV_STATE_MULTIHOP_1_FLYING_FINAL_POSITION_MANUAL = 18,
    UAV_STATE_MULTIHOP_1_REACHED_FINAL_POSITION = 19,
    UAV_STATE_MULTIHOP_2_WAITING = 20,
    UAV_STATE_MULTIHOP_2_FLYING_LAST_UAV = 21,
    UAV_STATE_MULTIHOP_2_REACHED_LAST_UAV = 22,
    UAV_STATE_MULTIHOP_2_FLYING_FINAL_POSITION = 23,
    UAV_STATE_MULTIHOP_2_REACHED_FINAL_POSITION = 24,
    UAV_STATE_MULTIHOP_3_WAITING = 25,
    UAV_STATE_MULTIHOP_3_FLYING_LAST_UAV = 26,
    UAV_STATE_MULTIHOP_3_REACHED_LAST_UAV = 27,
    UAV_STATE_MULTIHOP_3_FLYING_FINAL_POSITION = 28,
    UAV_STATE_MULTIHOP_3_REACHED_FINAL_POSITION = 29
};

enum UAV_SUBSCRIPTION {
    UAV_SUBSCRIPTION_SUBSCRIBE = 0,
    UAV_SUBSCRIPTION_UNSUBSCRIBE = 1
};

enum UAV_POSITIONING {
    UAV_POSITIONING_UNINITIALIZED = 0,
    UAV_POSITIONING_LOCATION = 1,
    UAV_POSITIONING_SIGNAL = 2
};

enum UAV_SEARCHING {
    UAV_SEARCHING_UNINITIALIZED = 0,
    UAV_SEARCHING_MANUAL = 1,
    UAV_SEARCHING_AUTONOMOUS = 2
};

enum UAV_RESPONSE {
    UAV_RESPONSE_SUCCESS = SUCCESS,
    UAV_RESPONSE_FAILURE = FAILURE,
    UAV_RESPONSE_UNKNOWN = UNKNOWN,
    UAV_RESPONSE_FLIGHT_DIRECTION_REQUEST
};

#endif

