#ifndef _GPS_H
#define _GPS_H

double rad2deg(double radian);
double deg2rad(double degree);
double rad2km(double radian, double radius);
double km2rad(double km, double radius);
void calcGPSPosition(double lat_deg, double lon_deg, double distance_deg, double angle_deg, double* newLat, double* newLon);
void calcSpiralWaypoints(GPS_Pos_t * spiralWaypoints, GPS_Pos_t position, double r, double incr_deg, int start_deg, int max_turns);
double calcBearing(double lat_deg_from, double lon_deg_from, double lat_deg_to, double lon_deg_to);
double negateBearing(double bearing_orig);
int isInTargetRange(GPS_Pos_t position, GPS_Pos_t target);

#endif
