#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <signal.h>
#include <netdb.h> 
#include <netinet/in.h>
#include "constants.h"
#include "socket.h"


//create the socket with integrated errorcheck
int createSocket ( int domain, int type, int protocol )
{
    int sockfd;
    sockfd = socket ( domain, type, protocol );
    if ( sockfd < 0 )
        printf ( "ERROR opening socket\n" );
    return sockfd;
}

//create the server with integrated errorcheck
int createServer ( struct hostent **server, char *hostname )
{
    int result = SUCCESS;
    if(!(*server = gethostbyname ( hostname )))
    {
        printf( "ERROR, no such host\n" );
        result = FAILURE;
        //exit(EXIT_FAILURE);
    }
    return result;
}

//initialize the serveraddress acting as client
void initServAddrClient ( struct hostent **server, struct sockaddr_in *serv_addr, int portno )
{
    memset ( ( char * ) serv_addr, '\0', sizeof ( *serv_addr ) );
    serv_addr->sin_family = AF_UNSPEC;
    memcpy ( ( char * ) & ( *serv_addr ).sin_addr.s_addr, ( char * ) ( *server )->h_addr, ( *server )->h_length );
    serv_addr->sin_port = htons ( portno );
    
}

//connect socket with server
void connectSocket ( int sockfd, struct sockaddr_in *serv_addr )
{
    if ( connect ( sockfd, ( struct sockaddr * ) serv_addr, sizeof ( *serv_addr ) ) < 0 )
    {
        printf ( "ERROR connecting" );
    }
}

//accept connections to socket
int acceptSocket ( int sockfd )
{
    socklen_t clilen;
    int newsockfd;
    struct sockaddr_in cli_addr;
    
    clilen = sizeof ( cli_addr );
    newsockfd = accept ( sockfd, ( struct sockaddr * ) &cli_addr, &clilen );
    if ( newsockfd < 0 )
    {
        printf ( "error on accept, interrupted system call\n" );
        return -1;

    }
    return newsockfd;
}

//initialize the serveraddress acting as server
void initServAddrServer ( struct sockaddr_in *serv_addr, int portno )
{
    memset ( ( char * ) serv_addr, '\0', sizeof ( *serv_addr ) );
    serv_addr->sin_family = AF_UNSPEC;
    serv_addr->sin_addr.s_addr = INADDR_ANY;
    serv_addr->sin_port = htons ( portno );
}

//bind socket on serveraddress
void bindSocket ( int sockfd, struct sockaddr_in *serv_addr )
{
    if ( bind ( sockfd, ( struct sockaddr * ) serv_addr,
                sizeof ( *serv_addr ) ) < 0 )
        error ( "ERROR on binding" );
}


void error ( char *msg )
{
    perror ( msg );
    exit ( EXIT_FAILURE );
}
