/* 
 * File:   controller.h
 * Author: smorgenthaler
 *
 * Created on August 19, 2010, 10:54 AM
 */

#ifndef _CONTROLLER_H
#define	_CONTROLLER_H

int initStatus(void);
int handlingCommunication(int sock);
int inNotificationSubscription(char *data, int sockfd);
void inSerialWaypoint ( char *data, int sockfd ); // 'X'
void inSerialOSDData(char *data); //'O'
int outSerialDebugInterval(int fd, uint8_t interval);
int outSerialLinkTest(int fd, uint16_t pattern);
int outSerialOSDInterval(int fd, uint8_t interval);
void outSerialRequestWaypoint ( unsigned char index, int fd );
void outSerialSelectNC(int fd); // n
int inPositionSubmission(char *data, int fd, int* waitForSocketInput, int sockfd);
int inAbort(char *data, int sockfd, int serialfd);
GPS_Pos_t getHomePosition();
int initMk(int serialfd);
int inFlightDirection(char *data, int fd, int sockfd);
void outSerialSelectFC(int fd); // f
void outSerialSendWaypoint ( GPS_Pos_t position, int correct, uint8_t wpindex, int fd );
void outSerialSendTarget ( GPS_Pos_t position, int correct, uint8_t wpindex, int fd );
int outSocketResponse(int sockfd, int response);
void calculateCenterPosition();
int checkInputs(int argc, char** argv);
void usage(char * self);
void handlingSerialInput(char *inputString, int length);
void inSerialLinkTest ( char *data );
int readSignalStrength(char *interface, long * clienssignals);
void inNbrOfWaypoints(char *data);
void inWaypoint(char *data);
NaviData_t getCurrentNaviData();
int getCurrentStatusState();
int getCurrentStatusScenario();
void setCurrentStatusPosition(NaviData_t navidata);
void setCurrentStatusConfiguration(int scenario, int searching, int positioning);
void setCurrentAllowedClients(AllowedClients_t allowedClients);
int isClientAllowed(uint8_t client[]);
void setCurrentStatusState(int state);
void setCurrentStatusClient1(Submitted_Pos_t position);
void setCurrentStatusClient2(Submitted_Pos_t position);
Submitted_Pos_t getCurrentStatusClient1();
Submitted_Pos_t getCurrentStatusClient2();
void setCurrentStatusHostname(char * hostname);
void setCurrentStatusIPv4(char * ipv4);
void setCurrentStatusMac(char * mac);
void outputCurrentScenario();
void outputCurrentClient1();
void outputCurrentClient2();
void getCurrentClient1MacString(char * mac);
void getCurrentClient2MacString(char * mac);
void setCurrentNaviData(NaviData_t navidata);
int checkForFinalPosition(int nbrWaypoints, int newState);
void handleUavs();
Status_t getUAVByState(int state);
void getConfigVariables();

#endif	/* _CONTROLLER_H */

