
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <unistd.h>
#include <stdlib.h>
#include <syslog.h>
#include <net/if.h>

#include "types.h"
#include "constants.h"
#include "pinger.h"

#define DEFAULT_IFACE "ath0"
#define PINGINTERVAL 3

void * ping(void *iface) {

    extern Status_t currentStatus;
    pthread_mutex_t currentStatusMutex;

    int sockfd_udp, ifn = 0;
    unsigned char command = 'p';
    char output[MAXLINELENGTH];
    char payload[MAXBUFLEN];
    Status_t status;
    
    memset(&status, '\0', sizeof(Status_t));

    ifn = getIfn((char*)iface);
    
    while (1) {
        sockfd_udp = generateControllerPingSocket(ifn);
        if (sockfd_udp < 0) {
            printf("error: open_ping_socket error\n");
            return;
        }
        memset(payload, '\0', sizeof (payload));
        memset(output, '\0', sizeof (output));

        pthread_mutex_lock(&currentStatusMutex);
	status = currentStatus;
        pthread_mutex_unlock(&currentStatusMutex);
	endian_swap_status(&status);
	
	memcpy((uint8_t *) & payload, (uint8_t *) & status, sizeof ( Status_t));        
	
        generateExternalCommand(command, payload, sizeof (Status_t), output);

        if (sendPing(sockfd_udp, output) == -1) {
            printf("sendto error");
            return;
        }
        closeSocket(sockfd_udp);

        sleep(PINGINTERVAL);
    }
}
