#include <time.h>
#include <termios.h>
#include <netinet/in.h>
#include <signal.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <unistd.h>
#include <stdlib.h>
#include <syslog.h>
#include <net/if.h>

#include "../uavext/uavext.h"
#include "../uavint/uavint.h"

#include "types.h"
#include "constants.h"
#include "serialreader.h"

struct sigaction osa;
  
struct thread_data{
    int  *fd;
    char *device;
};


void closeserial(int sig_no)
{
    printf("killing\n");
    sigaction(SIGINT, &osa, NULL);
    kill(0,SIGINT);
}

void * readserial(void *threadarg) {

    int *serialfd;
    char *serialdevice;
    struct thread_data *my_data;
    
    my_data = (struct thread_data *) threadarg;
    serialfd = my_data->fd;
    serialdevice = my_data->device;

    int tty;
    FILE *input;
    FILE *output;

    struct termios oldkey, newkey; //place for old and new port settings for keyboard teletype
    struct termios oldtio, newtio; //place for old and new port settings for serial port
    struct sigaction saio, osa; //definition of signal action
    memset(&saio, 0, sizeof (struct sigaction));
    saio.sa_handler = &closeserial;
    sigaction(SIGINT, &saio, &osa);
    openSerialPort(serialdevice, serialfd, &input, &output, &tty, &oldkey, &newkey, &saio, &oldtio, &newtio);
    
    char tmpSerialBuffer[4000];
    char serialBuffer[4000];
    int res;
    int loop = 1; /* loop while TRUE */
    memset(tmpSerialBuffer, '\0', sizeof (tmpSerialBuffer));
    memset(serialBuffer, '\0', sizeof (serialBuffer));
    int buf_pointer = 0;
    struct timeval serialTimeOut;
    serialTimeOut.tv_sec = 0;
    serialTimeOut.tv_usec = 10000;
    
    struct timespec timer; //timer
    timer.tv_sec  = 0;
    timer.tv_nsec = 1000000; //1msec
    int timerresult;
	  
    while (1) {
	memset(tmpSerialBuffer, '\0', sizeof (tmpSerialBuffer));
	res = read(*serialfd, tmpSerialBuffer, sizeof (tmpSerialBuffer));
	if (res >= 1 && tmpSerialBuffer[0] != '\n') {
	    int i = 0;
	    for(i = 0; i<res; i++) {
	      if(tmpSerialBuffer[i] != '\n' && !(tmpSerialBuffer[i] == '#' && buf_pointer > 0)) {
		  serialBuffer[buf_pointer++] = tmpSerialBuffer[i];
	      } else {
		serialBuffer[buf_pointer++] = tmpSerialBuffer[i];
		handlingSerialInput(serialBuffer, buf_pointer);
		memset(serialBuffer, '\0', sizeof (serialBuffer));
		buf_pointer = 0;
	      }
	      if(buf_pointer >= 3000) {
		memset(serialBuffer, '\0', sizeof (serialBuffer));
		buf_pointer = 0;
	      }
	    
	    }
	}
	timerresult = nanosleep(&timer,NULL);
    }
}
